var ACCF_NONE           = 0x00000000;
var ACCF_ACCOUNTING     = 0x00000001;
var ACCF_CASCADE_SERVER = 0x00000002;
var ACCF_CASCADE_CLIENT = 0x00000004;

var UPDATER_EXIT_OK               = 0;
var UPDATER_EXIT_UPDATE_AVAILABLE = 2;
var UPDATER_EXIT_CLIENT_DENIED    = 1008;
var UPDATER_EXIT_INVALID_PASSWORD = 2006;

var g_AjaxUpdateCheck = null;
var g_AjaxTimeout = null;
var g_CheckingUpdate = false;
var g_UpdateStatus = '';
var g_UpdateLastCheck = '[var.g_phpUpdLastCheck]';
var g_UpdateCheckResult = [var.g_phpCheckResult];
var g_UpdateVersion = '[var.g_phpUpdVersion]';

function OnLoad()
{
  if ( [var.g_phpApplyResult] >= 0 )
  {
    if ( [var.g_phpApplyResult] == 0 )
      alert ( "[var.str.setsyspwd_ok]" );
    else if ( [var.g_phpApplyResult] == 3 )
      alert ( "[var.str.setsyspwd_checkerror]" );
    else
      alert ( "[var.str.setsyspwd_failed]" );
  }

  SetUpdateInfoText (null);

  SwitchUpdateButtons();

  tbSetFocus ( "idCheckForUpdate" );
}

$(window).on('beforeunload', function()
{
  if ( g_AjaxTimeout != null )
  {
    clearTimeout ( g_AjaxTimeout );
    g_AjaxTimeout = null;
  }

  if (g_AjaxUpdateCheck != null)
  {
    g_AjaxUpdateCheck.abort();
    g_AjaxUpdateCheck = null;
  }
});


function SwitchUpdateButtons()
{
  if (([var._SESSION.features] == ACCF_CASCADE_CLIENT || [var._SESSION.debug] == 1) &&
       [var._SESSION.gpdclient] != 2)
  {
    $('#idOnlineUpdatePanel').show();

    var addr = $('input[name=htmlUpdSrvAddr]').val();
    var bHttps     = addr.substr(0,8).toUpperCase() == 'https://'.toUpperCase() ? true : false;
    var bHttp      = addr.substr(0,7).toUpperCase() == 'http://'.toUpperCase() ? true : false;
    var bAddrValid = bHttps || bHttp;

    $('#idCheckForUpdate').prop ('disabled', !bAddrValid);
    $('#idUpdActive').prop('disabled', !bAddrValid);
  }
  else
    $('#idUpdActive').prop('checked', false);
}


function OnCheckNow()
{
  g_CheckingUpdate = true;
  g_UpdateStatus = '';

  if ( g_AjaxTimeout != null )
  {
    clearTimeout ( g_AjaxTimeout );
    g_AjaxTimeout = null;
  }

  var bUpdate = $('#idCheckForUpdate').attr("data-update") != undefined ? true : false;

  if (bUpdate)
    TINY.box.show ( '#idUpdateWarnDlg', 0, 0, 0, false, -1, 1 );
  else
  {
    SetUpdateInfoText ('[var.str.upd_checking]...');

    CallUpdateCheck (false);
  }
}


function OnUpdateConfirmed ()
{
  TINY.box.hide();

  SetUpdateInfoText ('[var.str.upd_installing]...');

  CallUpdateCheck (true);
}


function CallUpdateCheck (bUpdate)
{
  if (g_AjaxUpdateCheck != null)
    g_AjaxUpdateCheck.abort();

  g_AjaxTimeout = null;

  $('#idCheckForUpdate').prop ('disabled', true);

  var Params = {};

  Params['ajhAction'] = 'phpUpdateCheck';
  Params['checkonly'] = !bUpdate ? 'yes' : 'no';

  if (bUpdate)
    tbShowInfoDialog ('[var.str.upd_caption]', '[var.str.upd_downloading]...');

  g_AjaxUpdateCheck = $.ajax (
      {
        url:      '[var.g_phpSelf]',
        type:     "POST",
        data:     Params,
        dataType: "json"
      });

      g_AjaxUpdateCheck.done (function (data, textStatus, jqXHR)
      {
        g_AjaxUpdateCheck = null;

        if (data != null)
          data['checkonly'] = Params['checkonly'];

        if (bUpdate)
          tbHideInfoDialog ();

        OnUpdateChecked (data);
      });


      g_AjaxUpdateCheck.fail (function (jqXHR, textStatus, errorThrown)
      {
        g_AjaxUpdateCheck = null;

        OnUpdateChecked (null);

        if (bUpdate)
          tbHideInfoDialog ();

        tbServiceDisconnected(false);
      });
}


function OnUpdateChecked (Result)
{
  g_AjaxUpdateCheck = null;
  g_AjaxTimeout     = null;

  var bUpdateAvailable = false;

  if (Result != null && Result['code'] == 0)
  {
    if (Result['checkonly'] == 'no')
    { // Das Update wurde ausgelst
      tbServiceDisconnected(true);
    }
    else
    {
      g_UpdateStatus      = Result['update_status'];
      g_UpdateLastCheck   = Result['lastcheck'];
      g_UpdateCheckResult = Result['check_result'];
      g_UpdateVersion     = Result['available_version'];

      if (g_UpdateStatus != '')
      {
        g_AjaxTimeout = setTimeout ( function(){ CallUpdateCheck() }, 5000 );
      }
      else
      {
        g_CheckingUpdate = false;

        if (g_UpdateCheckResult == UPDATER_EXIT_UPDATE_AVAILABLE)
          bUpdateAvailable = true;
      }
    }

    SetUpdateInfoText (null);
  }
  else
  {
    g_CheckingUpdate = false;
    SetUpdateInfoText ('[var.str.upd_check_failed]');
  }

  SetUpdateButtonState (bUpdateAvailable);

  if (g_AjaxTimeout == null)
    $('#idCheckForUpdate').prop ('disabled', false);
}


function SetUpdateInfoText (text)
{
  // Datum, bzw. aktuelle Aktion
  if (text != null)
    $('#idUpdLastCheck').addClass ("updcheckactive");
  else
    $('#idUpdLastCheck').removeClass ("updcheckactive");

  if (text == null && g_UpdateCheckResult >= 1000)
    $('#idUpdCheckResult').addClass ("upderror");
  else
    $('#idUpdCheckResult').removeClass ("upderror");

  // Zusatzinformation
  var resulttext = '';

  if (text == null)
  {
    if (g_UpdateStatus != '')
      resulttext = UpdateStatus2Text (g_UpdateStatus);
    else if (g_UpdateCheckResult == UPDATER_EXIT_UPDATE_AVAILABLE)
    {
      resulttext = '[var.str.upd_available1] ' + tbFriendlyVersion(g_UpdateVersion);
      if ('[var.str.upd_available2]' != '')
        resulttext += ' [var.str.upd_available2]';
    }
    else
      resulttext = UpdateError2Text(g_UpdateCheckResult);

    if (resulttext != '')
      resulttext = ' (' + resulttext + ')';
  }

  if (text == null)
    text = g_UpdateLastCheck;

  $('#idUpdLastCheck').text (text);
  $('#idUpdCheckResult').text (text != '-' ? resulttext : '');
}


function SetUpdateButtonState (bUpdate)
{
  if (bUpdate)
  {
    $('#idCheckForUpdate').attr("data-update","1");
    $('#idCheckForUpdate').text ('[var.str.upd_update_now]');
  }
  else
  {
    $('#idCheckForUpdate').attr("data-update", null);
    $('#idCheckForUpdate').text ('[var.str.upd_check_now]');
  }
}


function UpdateStatus2Text (Status)
{
  var text = '';

  if (Status.toLowerCase() == 'download')
    text = '[var.str.upd_downloading]...';
  else if (Status.toLowerCase() == 'unpack')
    text = '[var.str.upd_unpacking]...';
  else if (Status.toLowerCase() == 'setup')
    text = '[var.str.upd_installing]...';
  else if (Status.toLowerCase() == 'check' || Status != '')
    text = '[var.str.upd_checking]...';

  return text;
}


function UpdateError2Text (code)
{
  var text = '';

  if (g_UpdateCheckResult == UPDATER_EXIT_OK)
    text = '[var.str.upd_uptodate]';
  else if (g_UpdateCheckResult == UPDATER_EXIT_CLIENT_DENIED)
    text = '[var.str.upd_client_denied]';
  else if (g_UpdateCheckResult == UPDATER_EXIT_INVALID_PASSWORD)
    text = '[var.str.upd_invalid_password]';
  else if (code >= 2000 && code <= 2099)
    text = '[var.str.upd_err_200x;noerr]';
  else if (code >= 3000 && code <= 3099)
    text = '[var.str.upd_err_300x;noerr]';
  else if (code >= 4000 && code <= 4099)
    text = '[var.str.upd_err_400x;noerr]';
  else if (code == 5002)
    text = '[var.str.upd_err_5002;noerr]';
  else if (code >= 5000 && code <= 5099)
    text = '[var.str.upd_err_500x;noerr]';

  if (code != UPDATER_EXIT_OK)
  {
    if (code == -1)
      text = '[var.str.upd_unknown_error]';
    else if (text != '')
      text = code + ': ' + text;
    else
      text = '[var.str.upd_errorcode;noerr] ' + code;
  }

  return text;
}


function OnApplyButtonClick()
{
  with ( document.SettingsForm )
  {
    htmlCurrentPwd.value = tbGetValue ( "CurrentPwdEdit" );
    htmlNewPwd.value = tbGetValue ( "NewPwdEdit" );
    htmlCheckPwd.value = tbGetValue ( "CheckPwdEdit" );

    htmlSysEmail.value = tbGetValue ("idSystemEmail");

    if (([var._SESSION.features] == ACCF_CASCADE_CLIENT && [var._SESSION.gpdclient] != 2) || [var._SESSION.debug] == 1)
    {
      htmlUpdActive.value    = document.getElementById("idUpdActive").checked ? 1 : 0;
      htmlUpdLastCheck.value = document.getElementById("idUpdLastCheck").innerHTML;
    }
    else
      htmlUpdActive.value  = 0;

    htmlCsvDelimiter.value = tbGetSelectedOptionValue ( "CsvDelimiter" );
    htmlCsvSyncPrinters.value = document.getElementById("CsvSyncPrinters").checked ? 1 : 0;

    htmlAction.value = "DoApply";
    submit();
  }
}
